#include <iostream>
#include <string>

struct A {
    explicit A( std::string name ) :
        _name( std::move( name ) )
    {}

    const std::string &name() const {
        return _name;
    }
    const std::string &magicName() const {
        return "[" + _name + "]";
    }

private:
    std::string _name;
};

int main() {
    A instance( "foo" );
    std::cout << instance.magicName() << std::endl;
}
