#include <iostream>
#include <vector>
#include <algorithm>
#include <iterator>

struct A {
    explicit A( int stop ) :
        _numbers( stop )
    {
        for ( int i = 0; i < stop; ++i )
            _numbers[i] = i;
    }

    const std::vector< int > &numbers() const {
        return _numbers;
    }
    std::vector< int > magicNumbers() const {
        auto copy( _numbers );
        for ( int &i : copy )
            i *= 2;
        return copy;
    }

private:
    std::vector< int > _numbers;
};

int main() {
    A instance( 10 );

    // should print 0 2 4 6 8 10 12 14 16 18
    std::copy( instance.magicNumbers().begin(),
               instance.magicNumbers().end(),
               std::ostream_iterator< int >( std::cout, " " ) );
}
