#include <iostream>

struct Interface {
    virtual ~Interface() {
        cleanup();
    }
    void cleanup() { _cleanup(); }
private:
    virtual void _cleanup() = 0;
};

struct Instance : Interface {
private:
    void _cleanup() override {
        std::cout << "cleanup called" << std::endl;
    }
};

int main() {
    Instance i;
}
